/*
 * Copyright (c) 2001-2003 International Computer Science Institute
 * See LICENSE file for licensing, conditions, and warranties on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by 'clnt-gen'.
 *
 * $XORP: xorp/xrl/interfaces/rib_xif.hh,v 1.11 2003/05/24 23:35:28 mjh Exp $
 */

#ifndef __XRL_INTERFACES_RIB_XIF_HH__
#define __XRL_INTERFACES_RIB_XIF_HH__

#undef XORP_LIBRARY_NAME
#define XORP_LIBRARY_NAME "XifRib"

#include "libxorp/xlog.h"
#include "libxorp/callback.hh"

#include "libxipc/xrl.hh"
#include "libxipc/xrl_error.hh"
#include "libxipc/xrl_sender.hh"


class XrlRibV0p1Client {
public:
    XrlRibV0p1Client(XrlSender* s) : _sender(s) {}
    virtual ~XrlRibV0p1Client() {}

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB0;
    /**
     *  Send Xrl intended to:
     *  
     *  Enable/disable/start/stop RIB.
     *  
     *  @param tgt_name Xrl Target name
     */
    bool send_enable_rib(
	const char*	target_name, 
	const CB0&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB1;

    bool send_disable_rib(
	const char*	target_name, 
	const CB1&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB2;

    bool send_start_rib(
	const char*	target_name, 
	const CB2&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB3;

    bool send_stop_rib(
	const char*	target_name, 
	const CB3&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB4;
    /**
     *  Send Xrl intended to:
     *  
     *  Add/delete/enable/disable a RIB client. Add/delete/enable/disable a RIB
     *  client for a given target name, address family, and unicast/multicast
     *  flags.
     *  
     *  @param tgt_name Xrl Target name
     *  
     *  @param target_name the target name of the RIB client.
     *  
     *  @param unicast true if a client for the unicast RIB.
     *  
     *  @param multicast true if a client for the multicast RIB.
     */
    bool send_add_rib_client4(
	const char*	target_name, 
	const string&	target_name, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB4&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB5;

    bool send_add_rib_client6(
	const char*	target_name, 
	const string&	target_name, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB5&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB6;

    bool send_delete_rib_client4(
	const char*	target_name, 
	const string&	target_name, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB6&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB7;

    bool send_delete_rib_client6(
	const char*	target_name, 
	const string&	target_name, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB7&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB8;

    bool send_enable_rib_client4(
	const char*	target_name, 
	const string&	target_name, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB8&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB9;

    bool send_enable_rib_client6(
	const char*	target_name, 
	const string&	target_name, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB9&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB10;

    bool send_disable_rib_client4(
	const char*	target_name, 
	const string&	target_name, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB10&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB11;

    bool send_disable_rib_client6(
	const char*	target_name, 
	const string&	target_name, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB11&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB12;
    /**
     *  Send Xrl intended to:
     *  
     *  Don't send anything to the FEA - used for testing only
     *  
     *  @param tgt_name Xrl Target name
     */
    bool send_no_fea(
	const char*	target_name, 
	const CB12&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB13;
    /**
     *  Send Xrl intended to:
     *  
     *  Make errors fatal; used to detect errors we'd normally mask
     *  
     *  @param tgt_name Xrl Target name
     */
    bool send_make_errors_fatal(
	const char*	target_name, 
	const CB13&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB14;

    bool send_add_igp_table4(
	const char*	target_name, 
	const string&	protocol, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB14&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB15;

    bool send_add_igp_table6(
	const char*	target_name, 
	const string&	protocol, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB15&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB16;

    bool send_delete_igp_table4(
	const char*	target_name, 
	const string&	protocol, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB16&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB17;

    bool send_delete_igp_table6(
	const char*	target_name, 
	const string&	protocol, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB17&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB18;

    bool send_add_egp_table4(
	const char*	target_name, 
	const string&	protocol, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB18&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB19;

    bool send_add_egp_table6(
	const char*	target_name, 
	const string&	protocol, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB19&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB20;

    bool send_delete_egp_table4(
	const char*	target_name, 
	const string&	protocol, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB20&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB21;

    bool send_delete_egp_table6(
	const char*	target_name, 
	const string&	protocol, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB21&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB22;

    bool send_add_route4(
	const char*	target_name, 
	const string&	protocol, 
	const bool&	unicast, 
	const bool&	multicast, 
	const IPv4Net&	network, 
	const IPv4&	nexthop, 
	const uint32_t&	metric, 
	const CB22&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB23;

    bool send_add_route6(
	const char*	target_name, 
	const string&	protocol, 
	const bool&	unicast, 
	const bool&	multicast, 
	const IPv6Net&	network, 
	const IPv6&	nexthop, 
	const uint32_t&	metric, 
	const CB23&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB24;

    bool send_replace_route4(
	const char*	target_name, 
	const string&	protocol, 
	const bool&	unicast, 
	const bool&	multicast, 
	const IPv4Net&	network, 
	const IPv4&	nexthop, 
	const uint32_t&	metric, 
	const CB24&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB25;

    bool send_replace_route6(
	const char*	target_name, 
	const string&	protocol, 
	const bool&	unicast, 
	const bool&	multicast, 
	const IPv6Net&	network, 
	const IPv6&	nexthop, 
	const uint32_t&	metric, 
	const CB25&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB26;

    bool send_delete_route4(
	const char*	target_name, 
	const string&	protocol, 
	const bool&	unicast, 
	const bool&	multicast, 
	const IPv4Net&	network, 
	const CB26&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB27;

    bool send_delete_route6(
	const char*	target_name, 
	const string&	protocol, 
	const bool&	unicast, 
	const bool&	multicast, 
	const IPv6Net&	network, 
	const CB27&	cb
    );

    typedef XorpCallback2<void, const XrlError&, const IPv4*>::RefPtr CB28;
    /**
     *  Send Xrl intended to:
     *  
     *  Lookup nexthop.
     *  
     *  @param tgt_name Xrl Target name
     *  
     *  @param addr address to lookup.
     *  
     *  @param unicast look in unicast RIB.
     *  
     *  @param multicast look in multicast RIB.
     */
    bool send_lookup_route4(
	const char*	target_name, 
	const IPv4&	addr, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB28&	cb
    );

    typedef XorpCallback2<void, const XrlError&, const IPv6*>::RefPtr CB29;
    /**
     *  Send Xrl intended to:
     *  
     *  Lookup nexthop.
     *  
     *  @param tgt_name Xrl Target name
     *  
     *  @param addr address to lookup.
     *  
     *  @param unicast look in unicast RIB.
     *  
     *  @param multicast look in multicast RIB.
     */
    bool send_lookup_route6(
	const char*	target_name, 
	const IPv6&	addr, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB29&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB30;

    bool send_new_vif(
	const char*	target_name, 
	const string&	name, 
	const CB30&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB31;

    bool send_add_vif_addr4(
	const char*	target_name, 
	const string&	name, 
	const IPv4&	addr, 
	const IPv4Net&	subnet, 
	const CB31&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB32;

    bool send_add_vif_addr6(
	const char*	target_name, 
	const string&	name, 
	const IPv6&	addr, 
	const IPv6Net&	subnet, 
	const CB32&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB33;

    bool send_redist_enable4(
	const char*	target_name, 
	const string&	from, 
	const string&	to, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB33&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB34;

    bool send_redist_enable6(
	const char*	target_name, 
	const string&	from, 
	const string&	to, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB34&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB35;

    bool send_redist_disable4(
	const char*	target_name, 
	const string&	from, 
	const string&	to, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB35&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB36;

    bool send_redist_disable6(
	const char*	target_name, 
	const string&	from, 
	const string&	to, 
	const bool&	unicast, 
	const bool&	multicast, 
	const CB36&	cb
    );

    typedef XorpCallback7<void, const XrlError&, const bool*, const IPv4*, const uint32_t*, const uint32_t*, const IPv4*, const uint32_t*>::RefPtr CB37;
    /**
     *  Send Xrl intended to:
     *  
     *  Register an interest in a route
     *  
     *  @param tgt_name Xrl Target name
     *  
     *  @param target the name of the XRL module to notify when the information
     *  returned by this call becomes invalid.
     *  
     *  @param addr address of interest
     */
    bool send_register_interest4(
	const char*	target_name, 
	const string&	target, 
	const IPv4&	addr, 
	const CB37&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB38;
    /**
     *  Send Xrl intended to:
     *  
     *  De-register an interest in a route
     *  
     *  @param tgt_name Xrl Target name
     *  
     *  @param target the name of the XRL module that registered the interest
     *  
     *  @param addr the address of the previous registered interest. addr
     *  should be the base address of the add/prefix subnet.
     *  
     *  @param prefix the prefix length of the registered interest, as given in
     *  the response from register_interest.
     */
    bool send_deregister_interest4(
	const char*	target_name, 
	const string&	target, 
	const IPv4&	addr, 
	const uint32_t&	prefix, 
	const CB38&	cb
    );

    typedef XorpCallback7<void, const XrlError&, const bool*, const IPv6*, const uint32_t*, const uint32_t*, const IPv6*, const uint32_t*>::RefPtr CB39;
    /**
     *  Send Xrl intended to:
     *  
     *  Register an interest in a route
     *  
     *  @param tgt_name Xrl Target name
     *  
     *  @param target the name of the XRL module to notify when the information
     *  returned by this call becomes invalid.
     *  
     *  @param addr address of interest
     */
    bool send_register_interest6(
	const char*	target_name, 
	const string&	target, 
	const IPv6&	addr, 
	const CB39&	cb
    );

    typedef XorpCallback1<void, const XrlError&>::RefPtr CB40;
    /**
     *  Send Xrl intended to:
     *  
     *  De-register an interest in a route
     *  
     *  @param tgt_name Xrl Target name
     *  
     *  @param target the name of the XRL module that registered the interest
     *  
     *  @param addr the address of the previous registered interest. addr
     *  should be the base address of the add/prefix subnet.
     *  
     *  @param prefix the prefix length of the registered interest, as given in
     *  the response from register_interest.
     */
    bool send_deregister_interest6(
	const char*	target_name, 
	const string&	target, 
	const IPv6&	addr, 
	const uint32_t&	prefix, 
	const CB40&	cb
    );

protected:
    XrlSender* _sender;

private:
    void unmarshall0(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB0		cb
    );

    void unmarshall1(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB1		cb
    );

    void unmarshall2(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB2		cb
    );

    void unmarshall3(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB3		cb
    );

    void unmarshall4(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB4		cb
    );

    void unmarshall5(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB5		cb
    );

    void unmarshall6(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB6		cb
    );

    void unmarshall7(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB7		cb
    );

    void unmarshall8(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB8		cb
    );

    void unmarshall9(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB9		cb
    );

    void unmarshall10(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB10		cb
    );

    void unmarshall11(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB11		cb
    );

    void unmarshall12(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB12		cb
    );

    void unmarshall13(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB13		cb
    );

    void unmarshall14(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB14		cb
    );

    void unmarshall15(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB15		cb
    );

    void unmarshall16(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB16		cb
    );

    void unmarshall17(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB17		cb
    );

    void unmarshall18(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB18		cb
    );

    void unmarshall19(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB19		cb
    );

    void unmarshall20(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB20		cb
    );

    void unmarshall21(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB21		cb
    );

    void unmarshall22(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB22		cb
    );

    void unmarshall23(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB23		cb
    );

    void unmarshall24(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB24		cb
    );

    void unmarshall25(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB25		cb
    );

    void unmarshall26(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB26		cb
    );

    void unmarshall27(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB27		cb
    );

    void unmarshall28(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB28		cb
    );

    void unmarshall29(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB29		cb
    );

    void unmarshall30(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB30		cb
    );

    void unmarshall31(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB31		cb
    );

    void unmarshall32(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB32		cb
    );

    void unmarshall33(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB33		cb
    );

    void unmarshall34(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB34		cb
    );

    void unmarshall35(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB35		cb
    );

    void unmarshall36(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB36		cb
    );

    void unmarshall37(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB37		cb
    );

    void unmarshall38(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB38		cb
    );

    void unmarshall39(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB39		cb
    );

    void unmarshall40(
	const XrlError&	e, 
	XrlArgs*	a, 
	CB40		cb
    );

};

#endif /* __XRL_INTERFACES_RIB_XIF_HH__ */
