/*
 * Copyright (c) 2001-2003 International Computer Science Institute
 * See LICENSE file for licensing, conditions, and warranties on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by 'tgt-gen'.
 */

#ident "$XORP: xorp/xrl/targets/fea_base.cc,v 1.16 2003/06/01 22:34:01 hodson Exp $"


#include "fea_base.hh"

const XrlCmdError
XrlFeaTargetBase::handle_common_0_1_get_target_name(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling common/0.1/get_target_name", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    string name;
    try {
	XrlCmdError e = common_0_1_get_target_name(
	    name);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for common/0.1/get_target_name failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("name", name);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_common_0_1_get_version(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling common/0.1/get_version", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    string version;
    try {
	XrlCmdError e = common_0_1_get_version(
	    version);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for common/0.1/get_version failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("version", version);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_common_0_1_get_status(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling common/0.1/get_status", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t status;
    string reason;
    try {
	XrlCmdError e = common_0_1_get_status(
	    status,
	    reason);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for common/0.1/get_status failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("status", status);
	args->add("reason", reason);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_common_0_1_shutdown(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling common/0.1/shutdown", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = common_0_1_shutdown();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for common/0.1/shutdown failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_interface_names(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling ifmgr/0.1/get_all_interface_names", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    XrlAtomList ifnames;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_interface_names(
	    ifnames);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_interface_names failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("ifnames", ifnames);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_interface_names(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling ifmgr/0.1/get_configured_interface_names", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    XrlAtomList ifnames;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_interface_names(
	    ifnames);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_interface_names failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("ifnames", ifnames);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_vif_names(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling ifmgr/0.1/get_all_vif_names", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    XrlAtomList vifs;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_vif_names(
	    xrl.const_args().get_string("ifname"),
	    vifs);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_vif_names failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("vifs", vifs);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_vif_names(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling ifmgr/0.1/get_configured_vif_names", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    XrlAtomList vifs;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_vif_names(
	    xrl.const_args().get_string("ifname"),
	    vifs);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_vif_names failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("vifs", vifs);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_vif_flags(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling ifmgr/0.1/get_all_vif_flags", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool enabled;
    bool broadcast;
    bool loopback;
    bool point_to_point;
    bool multicast;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_vif_flags(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    enabled,
	    broadcast,
	    loopback,
	    point_to_point,
	    multicast);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_vif_flags failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("enabled", enabled);
	args->add("broadcast", broadcast);
	args->add("loopback", loopback);
	args->add("point_to_point", point_to_point);
	args->add("multicast", multicast);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_vif_flags(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling ifmgr/0.1/get_configured_vif_flags", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool enabled;
    bool broadcast;
    bool loopback;
    bool point_to_point;
    bool multicast;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_vif_flags(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    enabled,
	    broadcast,
	    loopback,
	    point_to_point,
	    multicast);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_vif_flags failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("enabled", enabled);
	args->add("broadcast", broadcast);
	args->add("loopback", loopback);
	args->add("point_to_point", point_to_point);
	args->add("multicast", multicast);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_vif_addresses4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling ifmgr/0.1/get_all_vif_addresses4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    XrlAtomList addresses;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_vif_addresses4(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    addresses);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_vif_addresses4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("addresses", addresses);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_vif_addresses4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling ifmgr/0.1/get_configured_vif_addresses4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    XrlAtomList addresses;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_vif_addresses4(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    addresses);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_vif_addresses4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("addresses", addresses);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_vif_addresses6(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling ifmgr/0.1/get_all_vif_addresses6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    XrlAtomList addresses;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_vif_addresses6(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    addresses);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_vif_addresses6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("addresses", addresses);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_vif_addresses6(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling ifmgr/0.1/get_configured_vif_addresses6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    XrlAtomList addresses;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_vif_addresses6(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    addresses);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_vif_addresses6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("addresses", addresses);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_address_flags4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_all_address_flags4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool enabled;
    bool broadcast;
    bool loopback;
    bool point_to_point;
    bool multicast;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_address_flags4(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"),
	    enabled,
	    broadcast,
	    loopback,
	    point_to_point,
	    multicast);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_address_flags4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("enabled", enabled);
	args->add("broadcast", broadcast);
	args->add("loopback", loopback);
	args->add("point_to_point", point_to_point);
	args->add("multicast", multicast);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_address_flags4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_configured_address_flags4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool enabled;
    bool broadcast;
    bool loopback;
    bool point_to_point;
    bool multicast;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_address_flags4(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"),
	    enabled,
	    broadcast,
	    loopback,
	    point_to_point,
	    multicast);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_address_flags4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("enabled", enabled);
	args->add("broadcast", broadcast);
	args->add("loopback", loopback);
	args->add("point_to_point", point_to_point);
	args->add("multicast", multicast);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_address_flags6(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_all_address_flags6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool enabled;
    bool loopback;
    bool point_to_point;
    bool multicast;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_address_flags6(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv6("address"),
	    enabled,
	    loopback,
	    point_to_point,
	    multicast);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_address_flags6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("enabled", enabled);
	args->add("loopback", loopback);
	args->add("point_to_point", point_to_point);
	args->add("multicast", multicast);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_address_flags6(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_configured_address_flags6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool enabled;
    bool loopback;
    bool point_to_point;
    bool multicast;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_address_flags6(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv6("address"),
	    enabled,
	    loopback,
	    point_to_point,
	    multicast);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_address_flags6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("enabled", enabled);
	args->add("loopback", loopback);
	args->add("point_to_point", point_to_point);
	args->add("multicast", multicast);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_interface_enabled(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling ifmgr/0.1/get_all_interface_enabled", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool enabled;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_interface_enabled(
	    xrl.const_args().get_string("ifname"),
	    enabled);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_interface_enabled failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("enabled", enabled);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_interface_enabled(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling ifmgr/0.1/get_configured_interface_enabled", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool enabled;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_interface_enabled(
	    xrl.const_args().get_string("ifname"),
	    enabled);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_interface_enabled failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("enabled", enabled);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_mac(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling ifmgr/0.1/get_all_mac", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    Mac mac;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_mac(
	    xrl.const_args().get_string("ifname"),
	    mac);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_mac failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("mac", mac);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_mac(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling ifmgr/0.1/get_configured_mac", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    Mac mac;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_mac(
	    xrl.const_args().get_string("ifname"),
	    mac);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_mac failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("mac", mac);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_mtu(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling ifmgr/0.1/get_all_mtu", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t mtu;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_mtu(
	    xrl.const_args().get_string("ifname"),
	    mtu);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_mtu failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("mtu", mtu);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_mtu(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling ifmgr/0.1/get_configured_mtu", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t mtu;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_mtu(
	    xrl.const_args().get_string("ifname"),
	    mtu);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_mtu failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("mtu", mtu);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_vif_enabled(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling ifmgr/0.1/get_all_vif_enabled", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool enabled;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_vif_enabled(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    enabled);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_vif_enabled failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("enabled", enabled);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_vif_enabled(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling ifmgr/0.1/get_configured_vif_enabled", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool enabled;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_vif_enabled(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    enabled);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_vif_enabled failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("enabled", enabled);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_prefix4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_all_prefix4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t prefix;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_prefix4(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"),
	    prefix);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_prefix4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("prefix", prefix);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_prefix4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_configured_prefix4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t prefix;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_prefix4(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"),
	    prefix);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_prefix4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("prefix", prefix);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_broadcast4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_all_broadcast4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    IPv4 broadcast;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_broadcast4(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"),
	    broadcast);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_broadcast4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("broadcast", broadcast);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_broadcast4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_configured_broadcast4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    IPv4 broadcast;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_broadcast4(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"),
	    broadcast);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_broadcast4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("broadcast", broadcast);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_endpoint4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_all_endpoint4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    IPv4 endpoint;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_endpoint4(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"),
	    endpoint);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_endpoint4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("endpoint", endpoint);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_endpoint4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_configured_endpoint4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    IPv4 endpoint;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_endpoint4(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"),
	    endpoint);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_endpoint4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("endpoint", endpoint);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_prefix6(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_all_prefix6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t prefix;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_prefix6(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv6("address"),
	    prefix);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_prefix6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("prefix", prefix);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_prefix6(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_configured_prefix6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t prefix;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_prefix6(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv6("address"),
	    prefix);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_prefix6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("prefix", prefix);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_endpoint6(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_all_endpoint6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    IPv6 endpoint;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_endpoint6(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv6("address"),
	    endpoint);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_endpoint6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("endpoint", endpoint);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_endpoint6(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_configured_endpoint6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    IPv6 endpoint;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_endpoint6(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv6("address"),
	    endpoint);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_endpoint6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("endpoint", endpoint);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_start_transaction(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling ifmgr/0.1/start_transaction", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t tid;
    try {
	XrlCmdError e = ifmgr_0_1_start_transaction(
	    tid);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/start_transaction failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("tid", tid);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_commit_transaction(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling ifmgr/0.1/commit_transaction", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_commit_transaction(
	    xrl.const_args().get_uint32("tid"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/commit_transaction failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_abort_transaction(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling ifmgr/0.1/abort_transaction", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_abort_transaction(
	    xrl.const_args().get_uint32("tid"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/abort_transaction failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_create_interface(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling ifmgr/0.1/create_interface", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_create_interface(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/create_interface failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_delete_interface(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling ifmgr/0.1/delete_interface", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_delete_interface(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/delete_interface failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_set_interface_enabled(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/set_interface_enabled", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_set_interface_enabled(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_bool("enabled"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/set_interface_enabled failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_set_mac(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/set_mac", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_set_mac(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_mac("mac"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/set_mac failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_set_mtu(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/set_mtu", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_set_mtu(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_uint32("mtu"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/set_mtu failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_create_vif(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/create_vif", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_create_vif(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/create_vif failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_delete_vif(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/delete_vif", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_delete_vif(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/delete_vif failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_set_vif_enabled(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 4) {
	XLOG_ERROR("Wrong number of arguments (%u != 4) handling ifmgr/0.1/set_vif_enabled", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_set_vif_enabled(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_bool("enabled"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/set_vif_enabled failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_create_address4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 4) {
	XLOG_ERROR("Wrong number of arguments (%u != 4) handling ifmgr/0.1/create_address4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_create_address4(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/create_address4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_delete_address4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 4) {
	XLOG_ERROR("Wrong number of arguments (%u != 4) handling ifmgr/0.1/delete_address4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_delete_address4(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/delete_address4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_set_address_enabled4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling ifmgr/0.1/set_address_enabled4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_set_address_enabled4(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"),
	    xrl.const_args().get_bool("enabled"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/set_address_enabled4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_address_enabled4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_all_address_enabled4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool enabled;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_address_enabled4(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"),
	    enabled);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_address_enabled4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("enabled", enabled);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_address_enabled4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_configured_address_enabled4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool enabled;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_address_enabled4(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"),
	    enabled);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_address_enabled4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("enabled", enabled);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_set_prefix4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling ifmgr/0.1/set_prefix4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_set_prefix4(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"),
	    xrl.const_args().get_uint32("prefix"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/set_prefix4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_set_broadcast4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling ifmgr/0.1/set_broadcast4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_set_broadcast4(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"),
	    xrl.const_args().get_ipv4("broadcast"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/set_broadcast4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_set_endpoint4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling ifmgr/0.1/set_endpoint4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_set_endpoint4(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv4("address"),
	    xrl.const_args().get_ipv4("endpoint"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/set_endpoint4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_create_address6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 4) {
	XLOG_ERROR("Wrong number of arguments (%u != 4) handling ifmgr/0.1/create_address6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_create_address6(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv6("address"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/create_address6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_delete_address6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 4) {
	XLOG_ERROR("Wrong number of arguments (%u != 4) handling ifmgr/0.1/delete_address6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_delete_address6(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv6("address"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/delete_address6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_set_address_enabled6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling ifmgr/0.1/set_address_enabled6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_set_address_enabled6(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv6("address"),
	    xrl.const_args().get_bool("enabled"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/set_address_enabled6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_all_address_enabled6(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_all_address_enabled6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool enabled;
    try {
	XrlCmdError e = ifmgr_0_1_get_all_address_enabled6(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv6("address"),
	    enabled);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_all_address_enabled6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("enabled", enabled);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_get_configured_address_enabled6(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling ifmgr/0.1/get_configured_address_enabled6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool enabled;
    try {
	XrlCmdError e = ifmgr_0_1_get_configured_address_enabled6(
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv6("address"),
	    enabled);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/get_configured_address_enabled6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("enabled", enabled);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_set_prefix6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling ifmgr/0.1/set_prefix6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_set_prefix6(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv6("address"),
	    xrl.const_args().get_uint32("prefix"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/set_prefix6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_set_endpoint6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling ifmgr/0.1/set_endpoint6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_set_endpoint6(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vif"),
	    xrl.const_args().get_ipv6("address"),
	    xrl.const_args().get_ipv6("endpoint"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/set_endpoint6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_register_client(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling ifmgr/0.1/register_client", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_register_client(
	    xrl.const_args().get_string("clientname"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/register_client failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_unregister_client(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling ifmgr/0.1/unregister_client", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_unregister_client(
	    xrl.const_args().get_string("clientname"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/unregister_client failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_register_all_interfaces_client(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling ifmgr/0.1/register_all_interfaces_client", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_register_all_interfaces_client(
	    xrl.const_args().get_string("clientname"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/register_all_interfaces_client failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_ifmgr_0_1_unregister_all_interfaces_client(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling ifmgr/0.1/unregister_all_interfaces_client", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = ifmgr_0_1_unregister_all_interfaces_client(
	    xrl.const_args().get_string("clientname"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for ifmgr/0.1/unregister_all_interfaces_client failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_fti_0_2_start_transaction(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling fti/0.2/start_transaction", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t tid;
    try {
	XrlCmdError e = fti_0_2_start_transaction(
	    tid);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/start_transaction failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("tid", tid);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_fti_0_2_commit_transaction(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/commit_transaction", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_commit_transaction(
	    xrl.const_args().get_uint32("tid"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/commit_transaction failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_fti_0_2_abort_transaction(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/abort_transaction", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_abort_transaction(
	    xrl.const_args().get_uint32("tid"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/abort_transaction failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_fti_0_2_add_entry4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 8) {
	XLOG_ERROR("Wrong number of arguments (%u != 8) handling fti/0.2/add_entry4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_add_entry4(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_ipv4net("dst"),
	    xrl.const_args().get_ipv4("gateway"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vifname"),
	    xrl.const_args().get_uint32("metric"),
	    xrl.const_args().get_uint32("admin_distance"),
	    xrl.const_args().get_string("protocol_origin"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/add_entry4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_fti_0_2_add_entry6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 8) {
	XLOG_ERROR("Wrong number of arguments (%u != 8) handling fti/0.2/add_entry6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_add_entry6(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_ipv6net("dst"),
	    xrl.const_args().get_ipv6("gateway"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vifname"),
	    xrl.const_args().get_uint32("metric"),
	    xrl.const_args().get_uint32("admin_distance"),
	    xrl.const_args().get_string("protocol_origin"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/add_entry6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_fti_0_2_delete_entry4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling fti/0.2/delete_entry4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_delete_entry4(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_ipv4net("dst"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/delete_entry4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_fti_0_2_delete_entry6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling fti/0.2/delete_entry6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_delete_entry6(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_ipv6net("dst"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/delete_entry6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_fti_0_2_delete_all_entries(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/delete_all_entries", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_delete_all_entries(
	    xrl.const_args().get_uint32("tid"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/delete_all_entries failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_fti_0_2_delete_all_entries4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/delete_all_entries4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_delete_all_entries4(
	    xrl.const_args().get_uint32("tid"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/delete_all_entries4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_fti_0_2_delete_all_entries6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/delete_all_entries6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_delete_all_entries6(
	    xrl.const_args().get_uint32("tid"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/delete_all_entries6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_fti_0_2_lookup_route4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/lookup_route4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    IPv4Net netmask;
    IPv4 gateway;
    string ifname;
    string vifname;
    uint32_t metric;
    uint32_t admin_distance;
    string protocol_origin;
    try {
	XrlCmdError e = fti_0_2_lookup_route4(
	    xrl.const_args().get_ipv4("dst"),
	    netmask,
	    gateway,
	    ifname,
	    vifname,
	    metric,
	    admin_distance,
	    protocol_origin);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/lookup_route4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("netmask", netmask);
	args->add("gateway", gateway);
	args->add("ifname", ifname);
	args->add("vifname", vifname);
	args->add("metric", metric);
	args->add("admin_distance", admin_distance);
	args->add("protocol_origin", protocol_origin);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_fti_0_2_lookup_route6(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/lookup_route6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    IPv6Net netmask;
    IPv6 gateway;
    string ifname;
    string vifname;
    uint32_t metric;
    uint32_t admin_distance;
    string protocol_origin;
    try {
	XrlCmdError e = fti_0_2_lookup_route6(
	    xrl.const_args().get_ipv6("dst"),
	    netmask,
	    gateway,
	    ifname,
	    vifname,
	    metric,
	    admin_distance,
	    protocol_origin);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/lookup_route6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("netmask", netmask);
	args->add("gateway", gateway);
	args->add("ifname", ifname);
	args->add("vifname", vifname);
	args->add("metric", metric);
	args->add("admin_distance", admin_distance);
	args->add("protocol_origin", protocol_origin);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_fti_0_2_lookup_entry4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/lookup_entry4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    IPv4 gateway;
    string ifname;
    string vifname;
    uint32_t metric;
    uint32_t admin_distance;
    string protocol_origin;
    try {
	XrlCmdError e = fti_0_2_lookup_entry4(
	    xrl.const_args().get_ipv4net("dst"),
	    gateway,
	    ifname,
	    vifname,
	    metric,
	    admin_distance,
	    protocol_origin);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/lookup_entry4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("gateway", gateway);
	args->add("ifname", ifname);
	args->add("vifname", vifname);
	args->add("metric", metric);
	args->add("admin_distance", admin_distance);
	args->add("protocol_origin", protocol_origin);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_fti_0_2_lookup_entry6(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/lookup_entry6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    IPv6 gateway;
    string ifname;
    string vifname;
    uint32_t metric;
    uint32_t admin_distance;
    string protocol_origin;
    try {
	XrlCmdError e = fti_0_2_lookup_entry6(
	    xrl.const_args().get_ipv6net("dst"),
	    gateway,
	    ifname,
	    vifname,
	    metric,
	    admin_distance,
	    protocol_origin);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/lookup_entry6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("gateway", gateway);
	args->add("ifname", ifname);
	args->add("vifname", vifname);
	args->add("metric", metric);
	args->add("admin_distance", admin_distance);
	args->add("protocol_origin", protocol_origin);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_raw_packet_0_1_send4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 8) {
	XLOG_ERROR("Wrong number of arguments (%u != 8) handling raw_packet/0.1/send4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = raw_packet_0_1_send4(
	    xrl.const_args().get_ipv4("src_address"),
	    xrl.const_args().get_ipv4("dst_address"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("proto"),
	    xrl.const_args().get_uint32("ttl"),
	    xrl.const_args().get_uint32("tos"),
	    xrl.const_args().get_binary("options"),
	    xrl.const_args().get_binary("payload"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for raw_packet/0.1/send4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_raw_packet_0_1_send_raw4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling raw_packet/0.1/send_raw4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = raw_packet_0_1_send_raw4(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_binary("packet"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for raw_packet/0.1/send_raw4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_raw_packet_0_1_register_vif_receiver(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 4) {
	XLOG_ERROR("Wrong number of arguments (%u != 4) handling raw_packet/0.1/register_vif_receiver", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = raw_packet_0_1_register_vif_receiver(
	    xrl.const_args().get_string("router_name"),
	    xrl.const_args().get_string("if_name"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("proto"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for raw_packet/0.1/register_vif_receiver failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlFeaTargetBase::handle_raw_packet_0_1_unregister_vif_receiver(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 4) {
	XLOG_ERROR("Wrong number of arguments (%u != 4) handling raw_packet/0.1/unregister_vif_receiver", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = raw_packet_0_1_unregister_vif_receiver(
	    xrl.const_args().get_string("router_name"),
	    xrl.const_args().get_string("if_name"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("proto"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for raw_packet/0.1/unregister_vif_receiver failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

