/*
 * Copyright (c) 2001-2003 International Computer Science Institute
 * See LICENSE file for licensing, conditions, and warranties on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by 'tgt-gen'.
 */

#ident "$XORP: xorp/xrl/targets/pim_base.cc,v 1.20 2003/06/01 22:34:03 hodson Exp $"


#include "pim_base.hh"

const XrlCmdError
XrlPimTargetBase::handle_common_0_1_get_target_name(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling common/0.1/get_target_name", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    string name;
    try {
	XrlCmdError e = common_0_1_get_target_name(
	    name);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for common/0.1/get_target_name failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("name", name);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_common_0_1_get_version(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling common/0.1/get_version", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    string version;
    try {
	XrlCmdError e = common_0_1_get_version(
	    version);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for common/0.1/get_version failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("version", version);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_common_0_1_get_status(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling common/0.1/get_status", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t status;
    string reason;
    try {
	XrlCmdError e = common_0_1_get_status(
	    status,
	    reason);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for common/0.1/get_status failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("status", status);
	args->add("reason", reason);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_common_0_1_shutdown(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling common/0.1/shutdown", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = common_0_1_shutdown();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for common/0.1/shutdown failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_cli_processor_0_1_process_command(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling cli_processor/0.1/process_command", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    string ret_processor_name;
    string ret_cli_term_name;
    uint32_t ret_cli_session_id;
    string ret_command_output;
    try {
	XrlCmdError e = cli_processor_0_1_process_command(
	    xrl.const_args().get_string("processor_name"),
	    xrl.const_args().get_string("cli_term_name"),
	    xrl.const_args().get_uint32("cli_session_id"),
	    xrl.const_args().get_string("command_name"),
	    xrl.const_args().get_string("command_args"),
	    ret_processor_name,
	    ret_cli_term_name,
	    ret_cli_session_id,
	    ret_command_output);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for cli_processor/0.1/process_command failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("ret_processor_name", ret_processor_name);
	args->add("ret_cli_term_name", ret_cli_term_name);
	args->add("ret_cli_session_id", ret_cli_session_id);
	args->add("ret_command_output", ret_command_output);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_new_vif(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling mfea_client/0.1/new_vif", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_new_vif(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("vif_index"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/new_vif failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_delete_vif(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling mfea_client/0.1/delete_vif", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_delete_vif(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/delete_vif failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_add_vif_addr4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling mfea_client/0.1/add_vif_addr4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_add_vif_addr4(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_ipv4("addr"),
	    xrl.const_args().get_ipv4net("subnet"),
	    xrl.const_args().get_ipv4("broadcast"),
	    xrl.const_args().get_ipv4("peer"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/add_vif_addr4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_add_vif_addr6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling mfea_client/0.1/add_vif_addr6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_add_vif_addr6(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_ipv6("addr"),
	    xrl.const_args().get_ipv6net("subnet"),
	    xrl.const_args().get_ipv6("broadcast"),
	    xrl.const_args().get_ipv6("peer"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/add_vif_addr6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_delete_vif_addr4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling mfea_client/0.1/delete_vif_addr4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_delete_vif_addr4(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_ipv4("addr"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/delete_vif_addr4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_delete_vif_addr6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling mfea_client/0.1/delete_vif_addr6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_delete_vif_addr6(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_ipv6("addr"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/delete_vif_addr6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_set_vif_flags(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 7) {
	XLOG_ERROR("Wrong number of arguments (%u != 7) handling mfea_client/0.1/set_vif_flags", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_set_vif_flags(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_bool("is_pim_register"),
	    xrl.const_args().get_bool("is_p2p"),
	    xrl.const_args().get_bool("is_loopback"),
	    xrl.const_args().get_bool("is_multicast"),
	    xrl.const_args().get_bool("is_broadcast"),
	    xrl.const_args().get_bool("is_up"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/set_vif_flags failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_set_all_vifs_done(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling mfea_client/0.1/set_all_vifs_done", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_set_all_vifs_done();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/set_all_vifs_done failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_is_vif_setup_completed(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling mfea_client/0.1/is_vif_setup_completed", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool is_completed;
    try {
	XrlCmdError e = mfea_client_0_1_is_vif_setup_completed(
	    is_completed);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/is_vif_setup_completed failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("is_completed", is_completed);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_recv_protocol_message4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 11) {
	XLOG_ERROR("Wrong number of arguments (%u != 11) handling mfea_client/0.1/recv_protocol_message4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_recv_protocol_message4(
	    xrl.const_args().get_string("xrl_sender_name"),
	    xrl.const_args().get_string("protocol_name"),
	    xrl.const_args().get_uint32("protocol_id"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("vif_index"),
	    xrl.const_args().get_ipv4("source_address"),
	    xrl.const_args().get_ipv4("dest_address"),
	    xrl.const_args().get_int32("ip_ttl"),
	    xrl.const_args().get_int32("ip_tos"),
	    xrl.const_args().get_bool("is_router_alert"),
	    xrl.const_args().get_binary("protocol_message"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/recv_protocol_message4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_recv_protocol_message6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 11) {
	XLOG_ERROR("Wrong number of arguments (%u != 11) handling mfea_client/0.1/recv_protocol_message6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_recv_protocol_message6(
	    xrl.const_args().get_string("xrl_sender_name"),
	    xrl.const_args().get_string("protocol_name"),
	    xrl.const_args().get_uint32("protocol_id"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("vif_index"),
	    xrl.const_args().get_ipv6("source_address"),
	    xrl.const_args().get_ipv6("dest_address"),
	    xrl.const_args().get_int32("ip_ttl"),
	    xrl.const_args().get_int32("ip_tos"),
	    xrl.const_args().get_bool("is_router_alert"),
	    xrl.const_args().get_binary("protocol_message"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/recv_protocol_message6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_recv_kernel_signal_message4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 9) {
	XLOG_ERROR("Wrong number of arguments (%u != 9) handling mfea_client/0.1/recv_kernel_signal_message4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_recv_kernel_signal_message4(
	    xrl.const_args().get_string("xrl_sender_name"),
	    xrl.const_args().get_string("protocol_name"),
	    xrl.const_args().get_uint32("protocol_id"),
	    xrl.const_args().get_uint32("message_type"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("vif_index"),
	    xrl.const_args().get_ipv4("source_address"),
	    xrl.const_args().get_ipv4("dest_address"),
	    xrl.const_args().get_binary("protocol_message"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/recv_kernel_signal_message4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_recv_kernel_signal_message6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 9) {
	XLOG_ERROR("Wrong number of arguments (%u != 9) handling mfea_client/0.1/recv_kernel_signal_message6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_recv_kernel_signal_message6(
	    xrl.const_args().get_string("xrl_sender_name"),
	    xrl.const_args().get_string("protocol_name"),
	    xrl.const_args().get_uint32("protocol_id"),
	    xrl.const_args().get_uint32("message_type"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("vif_index"),
	    xrl.const_args().get_ipv6("source_address"),
	    xrl.const_args().get_ipv6("dest_address"),
	    xrl.const_args().get_binary("protocol_message"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/recv_kernel_signal_message6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_add_mrib4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 7) {
	XLOG_ERROR("Wrong number of arguments (%u != 7) handling mfea_client/0.1/add_mrib4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_add_mrib4(
	    xrl.const_args().get_string("xrl_sender_name"),
	    xrl.const_args().get_ipv4net("dest_prefix"),
	    xrl.const_args().get_ipv4("next_hop_router_addr"),
	    xrl.const_args().get_string("next_hop_vif_name"),
	    xrl.const_args().get_uint32("next_hop_vif_index"),
	    xrl.const_args().get_uint32("metric_preference"),
	    xrl.const_args().get_uint32("metric"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/add_mrib4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_add_mrib6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 7) {
	XLOG_ERROR("Wrong number of arguments (%u != 7) handling mfea_client/0.1/add_mrib6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_add_mrib6(
	    xrl.const_args().get_string("xrl_sender_name"),
	    xrl.const_args().get_ipv6net("dest_prefix"),
	    xrl.const_args().get_ipv6("next_hop_router_addr"),
	    xrl.const_args().get_string("next_hop_vif_name"),
	    xrl.const_args().get_uint32("next_hop_vif_index"),
	    xrl.const_args().get_uint32("metric_preference"),
	    xrl.const_args().get_uint32("metric"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/add_mrib6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_delete_mrib4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling mfea_client/0.1/delete_mrib4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_delete_mrib4(
	    xrl.const_args().get_string("xrl_sender_name"),
	    xrl.const_args().get_ipv4net("dest_prefix"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/delete_mrib4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_delete_mrib6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling mfea_client/0.1/delete_mrib6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_delete_mrib6(
	    xrl.const_args().get_string("xrl_sender_name"),
	    xrl.const_args().get_ipv6net("dest_prefix"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/delete_mrib6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_set_mrib_done(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling mfea_client/0.1/set_mrib_done", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_set_mrib_done(
	    xrl.const_args().get_string("xrl_sender_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/set_mrib_done failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_recv_dataflow_signal4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 15) {
	XLOG_ERROR("Wrong number of arguments (%u != 15) handling mfea_client/0.1/recv_dataflow_signal4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_recv_dataflow_signal4(
	    xrl.const_args().get_string("xrl_sender_name"),
	    xrl.const_args().get_ipv4("source_address"),
	    xrl.const_args().get_ipv4("group_address"),
	    xrl.const_args().get_uint32("threshold_interval_sec"),
	    xrl.const_args().get_uint32("threshold_interval_usec"),
	    xrl.const_args().get_uint32("measured_interval_sec"),
	    xrl.const_args().get_uint32("measured_interval_usec"),
	    xrl.const_args().get_uint32("threshold_packets"),
	    xrl.const_args().get_uint32("threshold_bytes"),
	    xrl.const_args().get_uint32("measured_packets"),
	    xrl.const_args().get_uint32("measured_bytes"),
	    xrl.const_args().get_bool("is_threshold_in_packets"),
	    xrl.const_args().get_bool("is_threshold_in_bytes"),
	    xrl.const_args().get_bool("is_geq_upcall"),
	    xrl.const_args().get_bool("is_leq_upcall"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/recv_dataflow_signal4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mfea_client_0_1_recv_dataflow_signal6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 15) {
	XLOG_ERROR("Wrong number of arguments (%u != 15) handling mfea_client/0.1/recv_dataflow_signal6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mfea_client_0_1_recv_dataflow_signal6(
	    xrl.const_args().get_string("xrl_sender_name"),
	    xrl.const_args().get_ipv6("source_address"),
	    xrl.const_args().get_ipv6("group_address"),
	    xrl.const_args().get_uint32("threshold_interval_sec"),
	    xrl.const_args().get_uint32("threshold_interval_usec"),
	    xrl.const_args().get_uint32("measured_interval_sec"),
	    xrl.const_args().get_uint32("measured_interval_usec"),
	    xrl.const_args().get_uint32("threshold_packets"),
	    xrl.const_args().get_uint32("threshold_bytes"),
	    xrl.const_args().get_uint32("measured_packets"),
	    xrl.const_args().get_uint32("measured_bytes"),
	    xrl.const_args().get_bool("is_threshold_in_packets"),
	    xrl.const_args().get_bool("is_threshold_in_bytes"),
	    xrl.const_args().get_bool("is_geq_upcall"),
	    xrl.const_args().get_bool("is_leq_upcall"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mfea_client/0.1/recv_dataflow_signal6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_fti_0_2_start_transaction(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling fti/0.2/start_transaction", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t tid;
    try {
	XrlCmdError e = fti_0_2_start_transaction(
	    tid);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/start_transaction failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("tid", tid);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_fti_0_2_commit_transaction(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/commit_transaction", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_commit_transaction(
	    xrl.const_args().get_uint32("tid"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/commit_transaction failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_fti_0_2_abort_transaction(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/abort_transaction", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_abort_transaction(
	    xrl.const_args().get_uint32("tid"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/abort_transaction failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_fti_0_2_add_entry4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 8) {
	XLOG_ERROR("Wrong number of arguments (%u != 8) handling fti/0.2/add_entry4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_add_entry4(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_ipv4net("dst"),
	    xrl.const_args().get_ipv4("gateway"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vifname"),
	    xrl.const_args().get_uint32("metric"),
	    xrl.const_args().get_uint32("admin_distance"),
	    xrl.const_args().get_string("protocol_origin"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/add_entry4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_fti_0_2_add_entry6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 8) {
	XLOG_ERROR("Wrong number of arguments (%u != 8) handling fti/0.2/add_entry6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_add_entry6(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_ipv6net("dst"),
	    xrl.const_args().get_ipv6("gateway"),
	    xrl.const_args().get_string("ifname"),
	    xrl.const_args().get_string("vifname"),
	    xrl.const_args().get_uint32("metric"),
	    xrl.const_args().get_uint32("admin_distance"),
	    xrl.const_args().get_string("protocol_origin"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/add_entry6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_fti_0_2_delete_entry4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling fti/0.2/delete_entry4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_delete_entry4(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_ipv4net("dst"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/delete_entry4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_fti_0_2_delete_entry6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling fti/0.2/delete_entry6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_delete_entry6(
	    xrl.const_args().get_uint32("tid"),
	    xrl.const_args().get_ipv6net("dst"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/delete_entry6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_fti_0_2_delete_all_entries(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/delete_all_entries", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_delete_all_entries(
	    xrl.const_args().get_uint32("tid"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/delete_all_entries failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_fti_0_2_delete_all_entries4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/delete_all_entries4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_delete_all_entries4(
	    xrl.const_args().get_uint32("tid"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/delete_all_entries4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_fti_0_2_delete_all_entries6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/delete_all_entries6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = fti_0_2_delete_all_entries6(
	    xrl.const_args().get_uint32("tid"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/delete_all_entries6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_fti_0_2_lookup_route4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/lookup_route4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    IPv4Net netmask;
    IPv4 gateway;
    string ifname;
    string vifname;
    uint32_t metric;
    uint32_t admin_distance;
    string protocol_origin;
    try {
	XrlCmdError e = fti_0_2_lookup_route4(
	    xrl.const_args().get_ipv4("dst"),
	    netmask,
	    gateway,
	    ifname,
	    vifname,
	    metric,
	    admin_distance,
	    protocol_origin);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/lookup_route4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("netmask", netmask);
	args->add("gateway", gateway);
	args->add("ifname", ifname);
	args->add("vifname", vifname);
	args->add("metric", metric);
	args->add("admin_distance", admin_distance);
	args->add("protocol_origin", protocol_origin);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_fti_0_2_lookup_route6(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/lookup_route6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    IPv6Net netmask;
    IPv6 gateway;
    string ifname;
    string vifname;
    uint32_t metric;
    uint32_t admin_distance;
    string protocol_origin;
    try {
	XrlCmdError e = fti_0_2_lookup_route6(
	    xrl.const_args().get_ipv6("dst"),
	    netmask,
	    gateway,
	    ifname,
	    vifname,
	    metric,
	    admin_distance,
	    protocol_origin);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/lookup_route6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("netmask", netmask);
	args->add("gateway", gateway);
	args->add("ifname", ifname);
	args->add("vifname", vifname);
	args->add("metric", metric);
	args->add("admin_distance", admin_distance);
	args->add("protocol_origin", protocol_origin);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_fti_0_2_lookup_entry4(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/lookup_entry4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    IPv4 gateway;
    string ifname;
    string vifname;
    uint32_t metric;
    uint32_t admin_distance;
    string protocol_origin;
    try {
	XrlCmdError e = fti_0_2_lookup_entry4(
	    xrl.const_args().get_ipv4net("dst"),
	    gateway,
	    ifname,
	    vifname,
	    metric,
	    admin_distance,
	    protocol_origin);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/lookup_entry4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("gateway", gateway);
	args->add("ifname", ifname);
	args->add("vifname", vifname);
	args->add("metric", metric);
	args->add("admin_distance", admin_distance);
	args->add("protocol_origin", protocol_origin);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_fti_0_2_lookup_entry6(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling fti/0.2/lookup_entry6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    IPv6 gateway;
    string ifname;
    string vifname;
    uint32_t metric;
    uint32_t admin_distance;
    string protocol_origin;
    try {
	XrlCmdError e = fti_0_2_lookup_entry6(
	    xrl.const_args().get_ipv6net("dst"),
	    gateway,
	    ifname,
	    vifname,
	    metric,
	    admin_distance,
	    protocol_origin);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for fti/0.2/lookup_entry6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("gateway", gateway);
	args->add("ifname", ifname);
	args->add("vifname", vifname);
	args->add("metric", metric);
	args->add("admin_distance", admin_distance);
	args->add("protocol_origin", protocol_origin);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mld6igmp_client_0_1_add_membership4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling mld6igmp_client/0.1/add_membership4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mld6igmp_client_0_1_add_membership4(
	    xrl.const_args().get_string("xrl_sender_name"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("vif_index"),
	    xrl.const_args().get_ipv4("source"),
	    xrl.const_args().get_ipv4("group"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mld6igmp_client/0.1/add_membership4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mld6igmp_client_0_1_add_membership6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling mld6igmp_client/0.1/add_membership6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mld6igmp_client_0_1_add_membership6(
	    xrl.const_args().get_string("xrl_sender_name"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("vif_index"),
	    xrl.const_args().get_ipv6("source"),
	    xrl.const_args().get_ipv6("group"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mld6igmp_client/0.1/add_membership6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mld6igmp_client_0_1_delete_membership4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling mld6igmp_client/0.1/delete_membership4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mld6igmp_client_0_1_delete_membership4(
	    xrl.const_args().get_string("xrl_sender_name"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("vif_index"),
	    xrl.const_args().get_ipv4("source"),
	    xrl.const_args().get_ipv4("group"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mld6igmp_client/0.1/delete_membership4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_mld6igmp_client_0_1_delete_membership6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling mld6igmp_client/0.1/delete_membership6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = mld6igmp_client_0_1_delete_membership6(
	    xrl.const_args().get_string("xrl_sender_name"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("vif_index"),
	    xrl.const_args().get_ipv6("source"),
	    xrl.const_args().get_ipv6("group"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for mld6igmp_client/0.1/delete_membership6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_enable_vif(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/enable_vif", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_enable_vif(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/enable_vif failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_disable_vif(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/disable_vif", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_disable_vif(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/disable_vif failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_start_vif(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/start_vif", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_start_vif(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/start_vif failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_stop_vif(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/stop_vif", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_stop_vif(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/stop_vif failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_enable_all_vifs(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/enable_all_vifs", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_enable_all_vifs();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/enable_all_vifs failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_disable_all_vifs(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/disable_all_vifs", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_disable_all_vifs();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/disable_all_vifs failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_start_all_vifs(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/start_all_vifs", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_start_all_vifs();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/start_all_vifs failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_stop_all_vifs(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/stop_all_vifs", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_stop_all_vifs();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/stop_all_vifs failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_enable_pim(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/enable_pim", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_enable_pim();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/enable_pim failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_disable_pim(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/disable_pim", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_disable_pim();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/disable_pim failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_enable_cli(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/enable_cli", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_enable_cli();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/enable_cli failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_disable_cli(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/disable_cli", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_disable_cli();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/disable_cli failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_start_pim(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/start_pim", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_start_pim();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/start_pim failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_stop_pim(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/stop_pim", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_stop_pim();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/stop_pim failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_start_cli(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/start_cli", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_start_cli();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/start_cli failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_stop_cli(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/stop_cli", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_stop_cli();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/stop_cli failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_enable_bsr(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/enable_bsr", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_enable_bsr();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/enable_bsr failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_disable_bsr(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/disable_bsr", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_disable_bsr();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/disable_bsr failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_start_bsr(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/start_bsr", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_start_bsr();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/start_bsr failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_stop_bsr(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/stop_bsr", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_stop_bsr();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/stop_bsr failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_config_scope_zone_by_vif_name4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/add_config_scope_zone_by_vif_name4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_config_scope_zone_by_vif_name4(
	    xrl.const_args().get_ipv4net("scope_zone_id"),
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_config_scope_zone_by_vif_name4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_config_scope_zone_by_vif_name6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/add_config_scope_zone_by_vif_name6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_config_scope_zone_by_vif_name6(
	    xrl.const_args().get_ipv6net("scope_zone_id"),
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_config_scope_zone_by_vif_name6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_config_scope_zone_by_vif_addr4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/add_config_scope_zone_by_vif_addr4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_config_scope_zone_by_vif_addr4(
	    xrl.const_args().get_ipv4net("scope_zone_id"),
	    xrl.const_args().get_ipv4("vif_addr"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_config_scope_zone_by_vif_addr4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_config_scope_zone_by_vif_addr6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/add_config_scope_zone_by_vif_addr6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_config_scope_zone_by_vif_addr6(
	    xrl.const_args().get_ipv6net("scope_zone_id"),
	    xrl.const_args().get_ipv6("vif_addr"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_config_scope_zone_by_vif_addr6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_delete_config_scope_zone_by_vif_name4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/delete_config_scope_zone_by_vif_name4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_delete_config_scope_zone_by_vif_name4(
	    xrl.const_args().get_ipv4net("scope_zone_id"),
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/delete_config_scope_zone_by_vif_name4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_delete_config_scope_zone_by_vif_name6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/delete_config_scope_zone_by_vif_name6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_delete_config_scope_zone_by_vif_name6(
	    xrl.const_args().get_ipv6net("scope_zone_id"),
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/delete_config_scope_zone_by_vif_name6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_delete_config_scope_zone_by_vif_addr4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/delete_config_scope_zone_by_vif_addr4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_delete_config_scope_zone_by_vif_addr4(
	    xrl.const_args().get_ipv4net("scope_zone_id"),
	    xrl.const_args().get_ipv4("vif_addr"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/delete_config_scope_zone_by_vif_addr4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_delete_config_scope_zone_by_vif_addr6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/delete_config_scope_zone_by_vif_addr6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_delete_config_scope_zone_by_vif_addr6(
	    xrl.const_args().get_ipv6net("scope_zone_id"),
	    xrl.const_args().get_ipv6("vif_addr"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/delete_config_scope_zone_by_vif_addr6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_config_cand_bsr_by_vif_name4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling pim/0.1/add_config_cand_bsr_by_vif_name4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_config_cand_bsr_by_vif_name4(
	    xrl.const_args().get_ipv4net("scope_zone_id"),
	    xrl.const_args().get_bool("is_scope_zone"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("bsr_priority"),
	    xrl.const_args().get_uint32("hash_masklen"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_config_cand_bsr_by_vif_name4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_config_cand_bsr_by_vif_name6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling pim/0.1/add_config_cand_bsr_by_vif_name6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_config_cand_bsr_by_vif_name6(
	    xrl.const_args().get_ipv6net("scope_zone_id"),
	    xrl.const_args().get_bool("is_scope_zone"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("bsr_priority"),
	    xrl.const_args().get_uint32("hash_masklen"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_config_cand_bsr_by_vif_name6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_config_cand_bsr_by_addr4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling pim/0.1/add_config_cand_bsr_by_addr4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_config_cand_bsr_by_addr4(
	    xrl.const_args().get_ipv4net("scope_zone_id"),
	    xrl.const_args().get_bool("is_scope_zone"),
	    xrl.const_args().get_ipv4("cand_bsr_addr"),
	    xrl.const_args().get_uint32("bsr_priority"),
	    xrl.const_args().get_uint32("hash_masklen"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_config_cand_bsr_by_addr4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_config_cand_bsr_by_addr6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling pim/0.1/add_config_cand_bsr_by_addr6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_config_cand_bsr_by_addr6(
	    xrl.const_args().get_ipv6net("scope_zone_id"),
	    xrl.const_args().get_bool("is_scope_zone"),
	    xrl.const_args().get_ipv6("cand_bsr_addr"),
	    xrl.const_args().get_uint32("bsr_priority"),
	    xrl.const_args().get_uint32("hash_masklen"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_config_cand_bsr_by_addr6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_delete_config_cand_bsr4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/delete_config_cand_bsr4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_delete_config_cand_bsr4(
	    xrl.const_args().get_ipv4net("scope_zone_id"),
	    xrl.const_args().get_bool("is_scope_zone"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/delete_config_cand_bsr4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_delete_config_cand_bsr6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/delete_config_cand_bsr6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_delete_config_cand_bsr6(
	    xrl.const_args().get_ipv6net("scope_zone_id"),
	    xrl.const_args().get_bool("is_scope_zone"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/delete_config_cand_bsr6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_config_cand_rp_by_vif_name4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling pim/0.1/add_config_cand_rp_by_vif_name4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_config_cand_rp_by_vif_name4(
	    xrl.const_args().get_ipv4net("group_prefix"),
	    xrl.const_args().get_bool("is_scope_zone"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("rp_priority"),
	    xrl.const_args().get_uint32("rp_holdtime"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_config_cand_rp_by_vif_name4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_config_cand_rp_by_vif_name6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling pim/0.1/add_config_cand_rp_by_vif_name6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_config_cand_rp_by_vif_name6(
	    xrl.const_args().get_ipv6net("group_prefix"),
	    xrl.const_args().get_bool("is_scope_zone"),
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("rp_priority"),
	    xrl.const_args().get_uint32("rp_holdtime"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_config_cand_rp_by_vif_name6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_config_cand_rp_by_addr4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling pim/0.1/add_config_cand_rp_by_addr4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_config_cand_rp_by_addr4(
	    xrl.const_args().get_ipv4net("group_prefix"),
	    xrl.const_args().get_bool("is_scope_zone"),
	    xrl.const_args().get_ipv4("cand_rp_addr"),
	    xrl.const_args().get_uint32("rp_priority"),
	    xrl.const_args().get_uint32("rp_holdtime"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_config_cand_rp_by_addr4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_config_cand_rp_by_addr6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling pim/0.1/add_config_cand_rp_by_addr6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_config_cand_rp_by_addr6(
	    xrl.const_args().get_ipv6net("group_prefix"),
	    xrl.const_args().get_bool("is_scope_zone"),
	    xrl.const_args().get_ipv6("cand_rp_addr"),
	    xrl.const_args().get_uint32("rp_priority"),
	    xrl.const_args().get_uint32("rp_holdtime"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_config_cand_rp_by_addr6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_delete_config_cand_rp_by_vif_name4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling pim/0.1/delete_config_cand_rp_by_vif_name4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_delete_config_cand_rp_by_vif_name4(
	    xrl.const_args().get_ipv4net("group_prefix"),
	    xrl.const_args().get_bool("is_scope_zone"),
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/delete_config_cand_rp_by_vif_name4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_delete_config_cand_rp_by_vif_name6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling pim/0.1/delete_config_cand_rp_by_vif_name6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_delete_config_cand_rp_by_vif_name6(
	    xrl.const_args().get_ipv6net("group_prefix"),
	    xrl.const_args().get_bool("is_scope_zone"),
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/delete_config_cand_rp_by_vif_name6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_delete_config_cand_rp_by_addr4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling pim/0.1/delete_config_cand_rp_by_addr4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_delete_config_cand_rp_by_addr4(
	    xrl.const_args().get_ipv4net("group_prefix"),
	    xrl.const_args().get_bool("is_scope_zone"),
	    xrl.const_args().get_ipv4("cand_rp_addr"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/delete_config_cand_rp_by_addr4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_delete_config_cand_rp_by_addr6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling pim/0.1/delete_config_cand_rp_by_addr6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_delete_config_cand_rp_by_addr6(
	    xrl.const_args().get_ipv6net("group_prefix"),
	    xrl.const_args().get_bool("is_scope_zone"),
	    xrl.const_args().get_ipv6("cand_rp_addr"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/delete_config_cand_rp_by_addr6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_config_static_rp4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 4) {
	XLOG_ERROR("Wrong number of arguments (%u != 4) handling pim/0.1/add_config_static_rp4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_config_static_rp4(
	    xrl.const_args().get_ipv4net("group_prefix"),
	    xrl.const_args().get_ipv4("rp_addr"),
	    xrl.const_args().get_uint32("rp_priority"),
	    xrl.const_args().get_uint32("hash_masklen"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_config_static_rp4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_config_static_rp6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 4) {
	XLOG_ERROR("Wrong number of arguments (%u != 4) handling pim/0.1/add_config_static_rp6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_config_static_rp6(
	    xrl.const_args().get_ipv6net("group_prefix"),
	    xrl.const_args().get_ipv6("rp_addr"),
	    xrl.const_args().get_uint32("rp_priority"),
	    xrl.const_args().get_uint32("hash_masklen"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_config_static_rp6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_delete_config_static_rp4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/delete_config_static_rp4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_delete_config_static_rp4(
	    xrl.const_args().get_ipv4net("group_prefix"),
	    xrl.const_args().get_ipv4("rp_addr"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/delete_config_static_rp4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_delete_config_static_rp6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/delete_config_static_rp6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_delete_config_static_rp6(
	    xrl.const_args().get_ipv6net("group_prefix"),
	    xrl.const_args().get_ipv6("rp_addr"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/delete_config_static_rp6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_config_static_rp_done(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/config_static_rp_done", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_config_static_rp_done();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/config_static_rp_done failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_get_vif_proto_version(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/get_vif_proto_version", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t proto_version;
    try {
	XrlCmdError e = pim_0_1_get_vif_proto_version(
	    xrl.const_args().get_string("vif_name"),
	    proto_version);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/get_vif_proto_version failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("proto_version", proto_version);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_set_vif_proto_version(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/set_vif_proto_version", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_set_vif_proto_version(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("proto_version"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/set_vif_proto_version failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_reset_vif_proto_version(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/reset_vif_proto_version", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_reset_vif_proto_version(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/reset_vif_proto_version failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_get_vif_hello_triggered_delay(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/get_vif_hello_triggered_delay", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t hello_triggered_delay;
    try {
	XrlCmdError e = pim_0_1_get_vif_hello_triggered_delay(
	    xrl.const_args().get_string("vif_name"),
	    hello_triggered_delay);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/get_vif_hello_triggered_delay failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("hello_triggered_delay", hello_triggered_delay);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_set_vif_hello_triggered_delay(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/set_vif_hello_triggered_delay", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_set_vif_hello_triggered_delay(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("hello_triggered_delay"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/set_vif_hello_triggered_delay failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_reset_vif_hello_triggered_delay(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/reset_vif_hello_triggered_delay", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_reset_vif_hello_triggered_delay(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/reset_vif_hello_triggered_delay failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_get_vif_hello_period(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/get_vif_hello_period", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t hello_period;
    try {
	XrlCmdError e = pim_0_1_get_vif_hello_period(
	    xrl.const_args().get_string("vif_name"),
	    hello_period);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/get_vif_hello_period failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("hello_period", hello_period);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_set_vif_hello_period(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/set_vif_hello_period", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_set_vif_hello_period(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("hello_period"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/set_vif_hello_period failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_reset_vif_hello_period(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/reset_vif_hello_period", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_reset_vif_hello_period(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/reset_vif_hello_period failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_get_vif_hello_holdtime(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/get_vif_hello_holdtime", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t hello_holdtime;
    try {
	XrlCmdError e = pim_0_1_get_vif_hello_holdtime(
	    xrl.const_args().get_string("vif_name"),
	    hello_holdtime);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/get_vif_hello_holdtime failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("hello_holdtime", hello_holdtime);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_set_vif_hello_holdtime(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/set_vif_hello_holdtime", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_set_vif_hello_holdtime(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("hello_holdtime"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/set_vif_hello_holdtime failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_reset_vif_hello_holdtime(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/reset_vif_hello_holdtime", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_reset_vif_hello_holdtime(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/reset_vif_hello_holdtime failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_get_vif_dr_priority(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/get_vif_dr_priority", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t dr_priority;
    try {
	XrlCmdError e = pim_0_1_get_vif_dr_priority(
	    xrl.const_args().get_string("vif_name"),
	    dr_priority);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/get_vif_dr_priority failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("dr_priority", dr_priority);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_set_vif_dr_priority(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/set_vif_dr_priority", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_set_vif_dr_priority(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("dr_priority"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/set_vif_dr_priority failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_reset_vif_dr_priority(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/reset_vif_dr_priority", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_reset_vif_dr_priority(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/reset_vif_dr_priority failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_get_vif_lan_delay(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/get_vif_lan_delay", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t lan_delay;
    try {
	XrlCmdError e = pim_0_1_get_vif_lan_delay(
	    xrl.const_args().get_string("vif_name"),
	    lan_delay);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/get_vif_lan_delay failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("lan_delay", lan_delay);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_set_vif_lan_delay(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/set_vif_lan_delay", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_set_vif_lan_delay(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("lan_delay"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/set_vif_lan_delay failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_reset_vif_lan_delay(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/reset_vif_lan_delay", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_reset_vif_lan_delay(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/reset_vif_lan_delay failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_get_vif_override_interval(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/get_vif_override_interval", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t override_interval;
    try {
	XrlCmdError e = pim_0_1_get_vif_override_interval(
	    xrl.const_args().get_string("vif_name"),
	    override_interval);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/get_vif_override_interval failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("override_interval", override_interval);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_set_vif_override_interval(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/set_vif_override_interval", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_set_vif_override_interval(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("override_interval"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/set_vif_override_interval failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_reset_vif_override_interval(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/reset_vif_override_interval", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_reset_vif_override_interval(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/reset_vif_override_interval failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_get_vif_is_tracking_support_disabled(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/get_vif_is_tracking_support_disabled", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool is_tracking_support_disabled;
    try {
	XrlCmdError e = pim_0_1_get_vif_is_tracking_support_disabled(
	    xrl.const_args().get_string("vif_name"),
	    is_tracking_support_disabled);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/get_vif_is_tracking_support_disabled failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("is_tracking_support_disabled", is_tracking_support_disabled);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_set_vif_is_tracking_support_disabled(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/set_vif_is_tracking_support_disabled", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_set_vif_is_tracking_support_disabled(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_bool("is_tracking_support_disabled"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/set_vif_is_tracking_support_disabled failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_reset_vif_is_tracking_support_disabled(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/reset_vif_is_tracking_support_disabled", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_reset_vif_is_tracking_support_disabled(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/reset_vif_is_tracking_support_disabled failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_get_vif_accept_nohello_neighbors(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/get_vif_accept_nohello_neighbors", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool accept_nohello_neighbors;
    try {
	XrlCmdError e = pim_0_1_get_vif_accept_nohello_neighbors(
	    xrl.const_args().get_string("vif_name"),
	    accept_nohello_neighbors);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/get_vif_accept_nohello_neighbors failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("accept_nohello_neighbors", accept_nohello_neighbors);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_set_vif_accept_nohello_neighbors(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/set_vif_accept_nohello_neighbors", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_set_vif_accept_nohello_neighbors(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_bool("accept_nohello_neighbors"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/set_vif_accept_nohello_neighbors failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_reset_vif_accept_nohello_neighbors(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/reset_vif_accept_nohello_neighbors", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_reset_vif_accept_nohello_neighbors(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/reset_vif_accept_nohello_neighbors failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_get_vif_join_prune_period(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/get_vif_join_prune_period", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    uint32_t join_prune_period;
    try {
	XrlCmdError e = pim_0_1_get_vif_join_prune_period(
	    xrl.const_args().get_string("vif_name"),
	    join_prune_period);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/get_vif_join_prune_period failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("join_prune_period", join_prune_period);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_set_vif_join_prune_period(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/set_vif_join_prune_period", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_set_vif_join_prune_period(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_uint32("join_prune_period"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/set_vif_join_prune_period failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_reset_vif_join_prune_period(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/reset_vif_join_prune_period", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_reset_vif_join_prune_period(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/reset_vif_join_prune_period failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_get_switch_to_spt_threshold(const Xrl& xrl, XrlArgs* args)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/get_switch_to_spt_threshold", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    if (args == 0) {
	XLOG_FATAL("Return list empty");
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    bool is_enabled;
    uint32_t interval_sec;
    uint32_t bytes;
    try {
	XrlCmdError e = pim_0_1_get_switch_to_spt_threshold(
	    is_enabled,
	    interval_sec,
	    bytes);
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/get_switch_to_spt_threshold failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }

    /* Marshall return values */
    try {
	args->add("is_enabled", is_enabled);
	args->add("interval_sec", interval_sec);
	args->add("bytes", bytes);
    } catch (const XrlArgs::XrlAtomFound& ) {
	XLOG_FATAL("Duplicate atom name"); /* XXX Should never happen */
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_set_switch_to_spt_threshold(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 3) {
	XLOG_ERROR("Wrong number of arguments (%u != 3) handling pim/0.1/set_switch_to_spt_threshold", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_set_switch_to_spt_threshold(
	    xrl.const_args().get_bool("is_enabled"),
	    xrl.const_args().get_uint32("interval_sec"),
	    xrl.const_args().get_uint32("bytes"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/set_switch_to_spt_threshold failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_reset_switch_to_spt_threshold(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/reset_switch_to_spt_threshold", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_reset_switch_to_spt_threshold();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/reset_switch_to_spt_threshold failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_enable_log_trace(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/enable_log_trace", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_enable_log_trace();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/enable_log_trace failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_disable_log_trace(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/disable_log_trace", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_disable_log_trace();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/disable_log_trace failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_test_jp_entry4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 7) {
	XLOG_ERROR("Wrong number of arguments (%u != 7) handling pim/0.1/add_test_jp_entry4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_test_jp_entry4(
	    xrl.const_args().get_ipv4("source_addr"),
	    xrl.const_args().get_ipv4("group_addr"),
	    xrl.const_args().get_uint32("group_masklen"),
	    xrl.const_args().get_string("mrt_entry_type"),
	    xrl.const_args().get_string("action_jp"),
	    xrl.const_args().get_uint32("holdtime"),
	    xrl.const_args().get_bool("new_group_bool"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_test_jp_entry4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_test_jp_entry6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 7) {
	XLOG_ERROR("Wrong number of arguments (%u != 7) handling pim/0.1/add_test_jp_entry6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_test_jp_entry6(
	    xrl.const_args().get_ipv6("source_addr"),
	    xrl.const_args().get_ipv6("group_addr"),
	    xrl.const_args().get_uint32("group_masklen"),
	    xrl.const_args().get_string("mrt_entry_type"),
	    xrl.const_args().get_string("action_jp"),
	    xrl.const_args().get_uint32("holdtime"),
	    xrl.const_args().get_bool("new_group_bool"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_test_jp_entry6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_send_test_jp_entry4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/send_test_jp_entry4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_send_test_jp_entry4(
	    xrl.const_args().get_ipv4("nbr_addr"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/send_test_jp_entry4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_send_test_jp_entry6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/send_test_jp_entry6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_send_test_jp_entry6(
	    xrl.const_args().get_ipv6("nbr_addr"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/send_test_jp_entry6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_send_test_assert4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 6) {
	XLOG_ERROR("Wrong number of arguments (%u != 6) handling pim/0.1/send_test_assert4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_send_test_assert4(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_ipv4("source_addr"),
	    xrl.const_args().get_ipv4("group_addr"),
	    xrl.const_args().get_bool("rpt_bit"),
	    xrl.const_args().get_uint32("metric_preference"),
	    xrl.const_args().get_uint32("metric"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/send_test_assert4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_send_test_assert6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 6) {
	XLOG_ERROR("Wrong number of arguments (%u != 6) handling pim/0.1/send_test_assert6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_send_test_assert6(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_ipv6("source_addr"),
	    xrl.const_args().get_ipv6("group_addr"),
	    xrl.const_args().get_bool("rpt_bit"),
	    xrl.const_args().get_uint32("metric_preference"),
	    xrl.const_args().get_uint32("metric"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/send_test_assert6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_test_bsr_zone4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 6) {
	XLOG_ERROR("Wrong number of arguments (%u != 6) handling pim/0.1/add_test_bsr_zone4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_test_bsr_zone4(
	    xrl.const_args().get_ipv4net("zone_id_scope_zone_prefix"),
	    xrl.const_args().get_bool("zone_id_is_scope_zone"),
	    xrl.const_args().get_ipv4("bsr_addr"),
	    xrl.const_args().get_uint32("bsr_priority"),
	    xrl.const_args().get_uint32("hash_masklen"),
	    xrl.const_args().get_uint32("fragment_tag"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_test_bsr_zone4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_test_bsr_zone6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 6) {
	XLOG_ERROR("Wrong number of arguments (%u != 6) handling pim/0.1/add_test_bsr_zone6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_test_bsr_zone6(
	    xrl.const_args().get_ipv6net("zone_id_scope_zone_prefix"),
	    xrl.const_args().get_bool("zone_id_is_scope_zone"),
	    xrl.const_args().get_ipv6("bsr_addr"),
	    xrl.const_args().get_uint32("bsr_priority"),
	    xrl.const_args().get_uint32("hash_masklen"),
	    xrl.const_args().get_uint32("fragment_tag"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_test_bsr_zone6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_test_bsr_group_prefix4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling pim/0.1/add_test_bsr_group_prefix4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_test_bsr_group_prefix4(
	    xrl.const_args().get_ipv4net("zone_id_scope_zone_prefix"),
	    xrl.const_args().get_bool("zone_id_is_scope_zone"),
	    xrl.const_args().get_ipv4net("group_prefix"),
	    xrl.const_args().get_bool("is_scope_zone"),
	    xrl.const_args().get_uint32("expected_rp_count"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_test_bsr_group_prefix4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_test_bsr_group_prefix6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 5) {
	XLOG_ERROR("Wrong number of arguments (%u != 5) handling pim/0.1/add_test_bsr_group_prefix6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_test_bsr_group_prefix6(
	    xrl.const_args().get_ipv6net("zone_id_scope_zone_prefix"),
	    xrl.const_args().get_bool("zone_id_is_scope_zone"),
	    xrl.const_args().get_ipv6net("group_prefix"),
	    xrl.const_args().get_bool("is_scope_zone"),
	    xrl.const_args().get_uint32("expected_rp_count"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_test_bsr_group_prefix6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_test_bsr_rp4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 6) {
	XLOG_ERROR("Wrong number of arguments (%u != 6) handling pim/0.1/add_test_bsr_rp4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_test_bsr_rp4(
	    xrl.const_args().get_ipv4net("zone_id_scope_zone_prefix"),
	    xrl.const_args().get_bool("zone_id_is_scope_zone"),
	    xrl.const_args().get_ipv4net("group_prefix"),
	    xrl.const_args().get_ipv4("rp_addr"),
	    xrl.const_args().get_uint32("rp_priority"),
	    xrl.const_args().get_uint32("rp_holdtime"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_test_bsr_rp4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_add_test_bsr_rp6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 6) {
	XLOG_ERROR("Wrong number of arguments (%u != 6) handling pim/0.1/add_test_bsr_rp6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_add_test_bsr_rp6(
	    xrl.const_args().get_ipv6net("zone_id_scope_zone_prefix"),
	    xrl.const_args().get_bool("zone_id_is_scope_zone"),
	    xrl.const_args().get_ipv6net("group_prefix"),
	    xrl.const_args().get_ipv6("rp_addr"),
	    xrl.const_args().get_uint32("rp_priority"),
	    xrl.const_args().get_uint32("rp_holdtime"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/add_test_bsr_rp6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_send_test_bootstrap(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 1) {
	XLOG_ERROR("Wrong number of arguments (%u != 1) handling pim/0.1/send_test_bootstrap", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_send_test_bootstrap(
	    xrl.const_args().get_string("vif_name"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/send_test_bootstrap failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_send_test_bootstrap_by_dest4(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/send_test_bootstrap_by_dest4", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_send_test_bootstrap_by_dest4(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_ipv4("dest_addr"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/send_test_bootstrap_by_dest4 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_send_test_bootstrap_by_dest6(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 2) {
	XLOG_ERROR("Wrong number of arguments (%u != 2) handling pim/0.1/send_test_bootstrap_by_dest6", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_send_test_bootstrap_by_dest6(
	    xrl.const_args().get_string("vif_name"),
	    xrl.const_args().get_ipv6("dest_addr"));
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/send_test_bootstrap_by_dest6 failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

const XrlCmdError
XrlPimTargetBase::handle_pim_0_1_send_test_cand_rp_adv(const Xrl& xrl, XrlArgs* /* args */)
{
    if (xrl.const_args().size() != 0) {
	XLOG_ERROR("Wrong number of arguments (%u != 0) handling pim/0.1/send_test_cand_rp_adv", (uint32_t)xrl.const_args().size());
	return XrlCmdError::BAD_ARGS();
    }

    /* Return value declarations */
    try {
	XrlCmdError e = pim_0_1_send_test_cand_rp_adv();
	if (e != XrlCmdError::OKAY()) {
	    XLOG_WARNING("Handling method for pim/0.1/send_test_cand_rp_adv failed: %s",
            		 e.str().c_str());
	    return e;
        }
    } catch (const XrlArgs::XrlAtomNotFound& e) {
	XLOG_ERROR("Argument not found");
	return XrlCmdError::BAD_ARGS();
    }
    return XrlCmdError::OKAY();
}

